﻿namespace ComponentFramework.Structures
{
    public enum ButtonState
    {
        Up,
        Pressed,
        Released,
        Down
    }

    public static class ButtonStateExtensions
    {
        public static ButtonState NextState(this ButtonState state, bool pressed)
        {
            switch (state)
            {
                case ButtonState.Up:
                    return pressed ? ButtonState.Pressed : ButtonState.Up;
                case ButtonState.Pressed:
                    return pressed ? ButtonState.Down : ButtonState.Released;
                case ButtonState.Released:
                    return pressed ? ButtonState.Pressed : ButtonState.Up;
                default:
                case ButtonState.Down:
                    return pressed ? ButtonState.Down : ButtonState.Released;
            }
        }
    }
}
